/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/


void Form6::init()
{
  openMosixWrapper openmosix;
  
  listView1->clear();
  
  lineEdit1->setText(STRING(openmosix.getNodeId()));
  lineEdit2->setText(openmosix.getAutoMigration() ? "true" : "false");
  textEdit1->setText(openmosix.getNodeInfo());
  
  const QValueList<NODEINFO> nodeData = openmosix.getNodeData();
  
  for(QValueList<NODEINFO>::const_iterator i = nodeData.begin();i!=nodeData.end();i++)
  { 
    QListViewItem *item = new QListViewItem(listView1,
                                            STRING((*i).m_id),
                                            STRING((*i).m_cpus),
                                            STRING((*i).m_load),
                                            STRING((*i).m_mem/(1024*1024))  + " Mb",
                                            STRING((*i).m_tmem/(1024*1024)) + " Mb",
                                            STRING((*i).m_speed),
                                            STRING((*i).m_status));
  }
}


void Form6::SLOT_refresh()
{
  init();
}
