/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/


static QValueList<JOBDATA> SHOWEDJOBS;


void Form7::init()
{
  m_timer = new QTimer(this);
  connect(m_timer,SIGNAL(timeout()),this,SLOT(SLOT_tick()));
  m_timer->start(2000);
}


QValueList<JOBDATA>::iterator Form7::findTaskJob( int task, int job)
{
  for(QValueList<JOBDATA>::iterator i=SHOWEDJOBS.begin();i!=SHOWEDJOBS.end();i++)
  {
    if((*i).m_taskId==task  && (*i).m_jobId==job)
    {
      return(i);
    }
  }
  
  return(SHOWEDJOBS.end());
}

void Form7::addTaskJob( int task, int job, JOBDATA &data )
{
  QValueList<JOBDATA>::iterator ret;
  
  ret =  findTaskJob(task,job);
  if(ret!=SHOWEDJOBS.end())
  {
    *ret = data; 
  } else SHOWEDJOBS.push_back(data);
}


void Form7::showList()
{
  // Set check flag
  for(QValueList<JOBDATA>::iterator i=SHOWEDJOBS.begin();i!=SHOWEDJOBS.end();i++)
  {
    (*i).m_flag=false;
  }
  
  QValueList<TASK *> taskList = TASK::getTaskList();
  
  for(QValueList<TASK *>::const_iterator i=taskList.begin();i!=taskList.end();i++)
  {
    QValueList<JOB *> jobList = (*i)->getJobList();
    
    for(QValueList<JOB *>::const_iterator j=jobList.begin();j!=jobList.end();j++)
    { 
      QValueList<JOBDATA>::iterator ret;
      
      // Check if job is running
      if((*j)->getJobStatusStr()!="RUNNING") continue;
      
      // Find task/job
      ret =  findTaskJob((*i)->getTaskN(),(*j)->getJobNumber());
      
      if(ret!=SHOWEDJOBS.end())
      {
        int where =openMosixWrapper::where((*j)->getPID());
        
        (*ret).m_item->setText(3,where ? STRING(where) : "local");
        (*ret).m_flag = true;
      } else {
                JOBDATA data;
                
                int where =openMosixWrapper::where((*j)->getPID());
                
                data.m_taskId = (*i)->getTaskN();
                data.m_jobId  = (*j)->getJobNumber();
                data.m_item   = new QListViewItem(listView1,
                                                  STRING(data.m_taskId),
                                                  STRING(data.m_jobId),
                                                  STRING((*j)->getPID()),
                                                  where ? STRING(where) : "local");
                data.m_flag   = true;
                addTaskJob(data.m_taskId,data.m_jobId,data);
              }
    }
  }
  
  // Delete jobs
  for(QValueList<JOBDATA>::iterator i=SHOWEDJOBS.begin();i!=SHOWEDJOBS.end();i++)
  {
    if((*i).m_flag==false)
    {
      delete (*i).m_item;
      i = SHOWEDJOBS.erase(i);
    }
  }

}

void Form7::SLOT_tick()
{
  showList();
}
