#ifndef CONFIGURATION_H
#define CONFIGURATION_H

#include <qsettings.h>



class CFG
{ 
  private:

  QSettings m_qs;  
    
  public:
  
  CFG(void);
  
  // --------------------------------------------------------------------------------
  // GET
  // --------------------------------------------------------------------------------
  QString getPovrayPath(void);
  QString getAttributeList(void);
  QString getTmpDir(void);
  int     getDefaultJobs(void);
  int     getDefaultW(void);
  int     getDefaultH(void);
  
      
  // --------------------------------------------------------------------------------
  // GET
  // --------------------------------------------------------------------------------
  bool setPovrayPath(const QString &path);
  bool setAttributeList(const QString &attrList);
  bool setTmpDir(const QString &dir);
  bool setDefaultJobs(int jobs);
  bool setDefaultW(int W);
  bool setDefaultH(int H);
  
};

#endif
