#ifndef UTILITY_H
#define UTILITY_H

#include <qstring.h>
#include <qlistview.h>


using namespace std;


template <class X> QString STRING(X x)
{
  return(QString::number(x)); 
}


inline int INT(const QString &str)
{
  if(str.isEmpty()) return(-1);

  return(str.toInt());
}


typedef struct  _JOBDATA
{
  int             m_taskId;
  int             m_jobId;
  QListViewItem * m_item;
  bool            m_flag;
  
} JOBDATA;


/*
inline void CERR(const QString &str)
{
  fprintf(stderr,"%s",(const char *) str);
}
*/

#define CERR(STR) fprintf(stderr,"file:%s line:%d - %s",__FILE__,__LINE__,(const char *) STR)


#endif

